package com.test;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.StringWriter;
import java.util.Date;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author Deepak
 */
public class IncludedServlet extends HttpServlet {
   
    /** 
    * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

		StringWriter stringWriter = new StringWriter();
		StringServletOutputStream stringServletOutputStream = new StringServletOutputStream(new ByteArrayOutputStream());
		IncludedRequestWrapper includedRequestWrapper = 
			new IncludedRequestWrapper(request);
		IncludedResponseWrapper includedResponseWrapper = 			
			new IncludedResponseWrapper(response, stringWriter, stringServletOutputStream);

		includedRequestWrapper.setAttribute("newDate", new Date());
		HttpSession session = includedRequestWrapper.getSession();
		session.setAttribute("name", new HttpSessionBindingListenerTest("attrib-" + Math.random()));

		ContainerResponse containerResponse = (ContainerResponse)request.getAttribute("container_response");
		StringBuffer markup = new StringBuffer("");
		RequestDispatcher rd = getServletContext().getRequestDispatcher("/WEB-INF/view.jsp");
		try {
			rd.include(includedRequestWrapper, includedResponseWrapper);
			StringBuffer writerOuput = stringWriter.getBuffer();
			String streamOutput = stringServletOutputStream.toString();
			if (writerOuput.length() > 0) {
				markup = writerOuput;
			} else if (streamOutput.length() > 0) {
				markup = new StringBuffer(streamOutput);
			}
		} catch (Exception e) {
			e.printStackTrace();
			markup.append(e.toString());
		}

		containerResponse.setContent(markup);
	} 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

		processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
		try {
			processRequest(request, response);	
		}catch(RuntimeException re) {
			re.printStackTrace();
		}
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
