
package com.test;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.StringWriter;
import java.util.zip.GZIPOutputStream;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Deepak
 */
public class MainServlet extends HttpServlet {
   
    /** 
    * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
		
		ServletContext servletContext = getServletContext().getContext("/SLIncludedServletApp");
		
		RequestDispatcher rd = servletContext.getRequestDispatcher("/IncludedServlet");

		MainRequestWrapper mainRequestWrapper = new MainRequestWrapper(request);
		MainResponseWrapper mainResponseWrapper = new MainResponseWrapper(response);
		
		ContainerRequest containerRequest = new ContainerRequest();
		ContainerResponse containerResponse = new ContainerResponse();

		mainRequestWrapper.setAttribute("container_request", containerRequest);
		mainRequestWrapper.setAttribute("container_response", containerResponse);
		rd.include(mainRequestWrapper, mainResponseWrapper);

		StringBuffer content = containerResponse.getContent();
		if(content == null) {
			content = new StringBuffer();
		}
		StringWriter stringWriter = new StringWriter();
		stringWriter.write("<html>");
		stringWriter.write("<head>");
		stringWriter.write("<title>Servlet NewServlet</title>");  
		stringWriter.write("</head>");
		stringWriter.write("<body>");
		stringWriter.write("<h1>Testing Servlet Listener invocations</h1>");
		stringWriter.write(content.toString());
		stringWriter.write("</body>");
		stringWriter.write("</html>");

		ServletOutputStream output = mainResponseWrapper.getOutputStream();
		output.println(stringWriter.toString());
		output.flush();
		output.close();
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
