package com.test;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import javax.servlet.ServletOutputStream;


public class StringServletOutputStream extends ServletOutputStream {

    private ByteArrayOutputStream byteArrayOutputStream;
    
    public StringServletOutputStream(ByteArrayOutputStream byteArrayOutputStream) {
        this.byteArrayOutputStream = byteArrayOutputStream;
    }

    @Override
    public void write(int b) throws IOException {
        this.byteArrayOutputStream.write(b);
    }

    public byte[] toByteArray() {
        return this.byteArrayOutputStream.toByteArray();
    }

    public String toString(String characterEncoding) throws UnsupportedEncodingException {
        return this.byteArrayOutputStream.toString(characterEncoding);
    }
    
    public void reset() {
        this.byteArrayOutputStream.reset();
    }

    public int size() {
        return this.byteArrayOutputStream.size();
    }

}
